--******************************************************************
--  Testbench for CPU32
--******************************************************************
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;
use work.cpupackage.ALL;
use work.debug.ALL;

ENTITY cpuTestbench IS
END cpuTestbench;

ARCHITECTURE behavior OF cpuTestbench IS 

-- Signals for UUT ports
SIGNAL reset :  std_logic;
SIGNAL clock :  std_logic;
SIGNAL pcOut :  std_logic_vector(31 downto 0);

constant clockHigh   : time := 50 ns; 
constant clockLow    : time := 50 ns; 
constant clockPeriod : time := clockHigh + clockLow; 

signal complete : boolean;

begin

   --****************************************************
   -- Clock Generator
   --
   ClockGen:
   process

   begin
      while not complete loop
         clock <= '0';  wait for clockHigh;
         clock <= '1';  wait for clockLow;
      end loop;

      wait; -- stop process looping
   end process ClockGen;

   uut:
   entity work.cpu32(Behavioral) PORT MAP(
         reset => reset,
         clock => clock,
         pcOut => pcOut
         );

   testbench:
   process

   begin

      reset <= '1';
      wait for 10 ns;
      wait until rising_edge(clock);
      reset <= '0';

      wait for 34000 ns;
      dwrite( string'("Simulation completed.") );

      -- end simulation
      complete <= true;
      wait;

   end process testbench;

end architecture behavior;
