
   mov   r6,#0x100
   mov   r15,#0x100
   st   r6,0x200
   st   r15,0x300

   bsr sort

   bra *


; very simplistic exchange sort

;  r1 = start of unsorted array
;  r2 = pointer past end of array, moves down 1 for each iteration
;  r3 = search ptr
;  r4 = highest value so far

sort
;   movh  r1,#(table>>16)
   mov   r1,#table
   add   r2,r1,#tableSize-4

loop
   mov   r3,r1       ; reset search ptr
;   ld.w  r4,(r3)     ; seed with first entry
;   ld.b  r4,(r3)     ; seed with first entry
   ld.l  r4,(r3)     ; seed with first entry

innerLoop
   ld    r5,4(r3)    ; get next value to check
   sub   r0,r4,r5    ; in order?
   bls   skip1       ; yes - skip

   st    r5,(r3)     ; exchange values
   st    r4,4(r3)
   bra   skip2

skip1
   mov   r4,r5

skip2
   add   r3,r3,#4    ; advance to next value
   sub   r0,r3,r2    ; at end of array?
   blo   innerLoop

   sub   r2,r2,#4    ; retreat end ptr
   sub   r0,r1,r2    ; done whole array?
   blo   loop        ; no - back for next iteration

   rts


   org   $80


table     dc.l  5,4,6,2,1
tableSize equ (*-table) ; size of table in bytes


; try the following tests

   bsr     doit

loop2
   
   bra     loop2

   bra     *
                           
doit
   movh  r2,#$1234        ; R2 <- $12345678
   add   r2,r2,#$5678

   add   r1,r2,#100
   add   r1,r2,#-100
   sub   r1,r2,#100
   sub   r1,r2,#-100
   add   r1,r2,#0xFFFF
   add   r1,r2,#-0xFFFF
;   add   r1,r2,#0x10000  ; too large
;   add   r1,r2,#-0x10000 ; too large

   mov   r1,#0x100
   mov   r1,#-0x100
   mov   r1,#0xFFFF      ; largest +ve number 
   mov   r1,#-0xFFFF     ; largest -ve number
;   mov   r1,#0x10000     ; 1 +ve too large
;   mov   r1,#-0x10000    ; 1 -ve too large

   mov    r2,r1

; pseudo
   mov   r1,r2
   neg   r1,r2
   com   r1,r2

   mov   r1,#0x100       ; r1 = 100
   mov   r2,#0x300       ; r2 = 300
   add   r1,r1,r2        ; r1 += r2          r1 <= 0x400
   st    r1,0x05A        ; mem(0x05A) = r1   mem(0x05A) <- 400
   sub   r2,r2,r1        ; r2 -= r1          r2 <= 0xFFFFFF00
   st    r2,0x05A        ; mem(0x05A) = r2   mem(0x05A) <- 0xFFFFFF00

   mov   r1,#0xFFFFAA55  ; r1 = 0xFFFFAA55
   mov   r2,#0xFFFFF5FA  ; r2 = 0xFFFFF5FA
   and   r1,r1,r2        ; r1 &= r2          r1 <= 0xFFFFA050
   eor   r1,r1,#0x0A05   ; r1 ^= 0x00000a05  r1 <= 0xFFFFAA55
   st    r1,0x05B        ; mem(0x05B) = r1   mem(0x05B) <- 0xFFFFAA55


   or    r4,r4,r6        ; r6 |= r6
   mov   r6,r8           ; r7  = r8
   swap  r7,r7,r9        ; r7  = swap(r9)

   add   r1,r1,#1           ; r1 += 1
   sub   r2,r2,#-1          ; r2 -= -1
   and   r3,r3,#3           ; r3 &= 3 
   or    r4,r4,#4           ; r4 |= 4 
   eor   r5,r5,#5           ; r5 ^= 5 
   mov   r6,#6           ; r6  = 6
   movh  r7,#7           ; r7  = 7

   mov   r1,#0x7FFF      ; largest +ve number 
   mov   r1,#0xFFFF8000  ; largest -ve number
;   mov   r1,#0x8000      ; 1 +ve too large
;   mov   r1,#0xFFFF7FFF  ; 1 -ve too large

   ld    r1,10(r9)
   ld    r2,10(r10)
   ld    r3,(r11)
   ld    r4,10

   st    r5,10(r12)
   st    r6,10(r13)
   st    r7,(r14)
   st    r8,10

   jmp   10(r15)
   jmp   10(r16)
   jmp   (r17)
   jmp   10


   bcs  *
   bcc  *
   blo  *
   bhs  *
   beq  *
   bne  *
   bvs  *
   bvc  *
   bmi  *
   bpl  *
   blt  *
   bge  *
   ble  *
   bgt  *
   bls  *
   bhi  *

   rts

   bra   loop

data2 equ   $1010
data  equ   $1000
